#include <iostream>
#include <fstream>
#include <stdlib.h>
#include <vector>

using namespace std;

struct Riik
{
    string nimi;
    float rahvaarv;
    int pindala;
    float tihedus;
    float erinevus;
};
vector<Riik> riigid;

void bubbleSort()//Bubble sort function
{
    int i,j;
    for(i=0;i<riigid.size();i++)
    {
        for(j=0;j<i;j++)
        {
            if(riigid[i].erinevus<riigid[j].erinevus)
            {
                Riik temp=riigid[i]; //swap
                riigid[i]=riigid[j];
                riigid[j]=temp;
            }
        }
    }
}

string parseValue(string line)
{
    int pos = line.find_first_of(">");
    line = line.substr(pos+1);
    pos = line.find_first_of("<");
    return line.substr(0,pos);
}

int main()
{
   ifstream in("..\\..\\EuroopaRiigid.xml");
    if(not in.is_open())
    {
        cout<<"Faili ei saa avada\n";
        return 1;
    }

        float rahvas = 0;
        int pind = 0;
        string line;
        getline(in,line); // 1. rida <xml>
        while(true)
        {
            getline(in,line);  // <EoroopaRiik
            if(line[1]=='/')
                break;

            Riik uus;
            getline(in,line);  // <Nimi>
            uus.nimi = parseValue(line);

            getline(in,line);  // <Rahvaarv>
            string s = parseValue(line);
            int p = s.find(",");
            int t = atoi(s.substr(0,p).c_str());
            int k = atoi(s.substr(p+1).c_str());
            uus.rahvaarv = 1000.0*t+100*k;

            getline(in,line);  // <Pindala>
            s = parseValue(line);
            uus.pindala = atoi(s.c_str());

            uus.tihedus = uus.rahvaarv/uus.pindala;
            rahvas += uus.rahvaarv;
            pind += uus.pindala;

            riigid.push_back(uus);
            getline(in,line);  // </EoroopaRiik
            //cout<<uus.rahvaarv<<"\t"<<uus.pindala<<endl;

            //getline(cin,line);
        }
        float tihe = rahvas/pind;
        cout<<"Keskmine tihedus = "<<tihe<<endl;

        for(int j=0;j<riigid.size();j++)
        {
            float delta = riigid[j].tihedus-tihe;
            if(delta<0)
                delta = -delta;
            riigid[j].erinevus = delta;
        }
        bubbleSort();
        for(int j=0;j<riigid.size();j++)
            cout<<riigid[j].erinevus<<"\t"
                   <<riigid[j].tihedus<<"\t"
                   <<riigid[j].nimi<<endl;
    return 0;
}
